//+------------------------------------------------------------------+
//|                                                  Force Index.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
//---- input parameters
extern bool Alerts_On = true;
extern double Alert_Trigger_Level = 0.03;
extern double Alert_Trigger_Leve2 = -0.03;
extern double Alert_Trigger_Leve3 = 0.05;
extern double Alert_Trigger_Leve4 = -0.05;

extern int ExtForcePeriod=13;
extern int ExtForceMAMethod=1;
extern int ExtForceAppliedPrice=0;

//---- buffers
double ExtForceBuffer[];
bool EntryAllowed;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string sShortName;
   SetIndexBuffer(0,ExtForceBuffer);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
//---- name for DataWindow and indicator subwindow label
   sShortName="Force("+ExtForcePeriod+")";
   IndicatorShortName(sShortName);
   SetIndexLabel(0,sShortName);
//---- first values aren't drawn
   SetIndexDrawBegin(0,ExtForcePeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Force Index indicator                                            |
//+------------------------------------------------------------------+
int start()
  {
   int nLimit;
   int nCountedBars=IndicatorCounted();
//---- insufficient data
   if(Bars<=ExtForcePeriod) return(0);
//---- last counted bar will be recounted
   if(nCountedBars>ExtForcePeriod) nCountedBars--;
   nLimit=Bars-nCountedBars;
//---- Force Index counted
   for(int i=nLimit; i>=0; i--)
   {
     Print(i);
      ExtForceBuffer[i]=Volume[i]*
                        (iMA(NULL,0,ExtForcePeriod,0,ExtForceMAMethod,ExtForceAppliedPrice,i)-
                         iMA(NULL,0,ExtForcePeriod,0,ExtForceMAMethod,ExtForceAppliedPrice,i+1));
  
  
   if (Alerts_On && i == 1) {
    if (MathAbs(ExtForceBuffer[i]) > Alert_Trigger_Level) {
     if (EntryAllowed) {
      Alert("ForceIndex Possible BUY watch out !... (M",Period()," ",Symbol(),")"); // alert by omelette
      EntryAllowed = false; } }
            else EntryAllowed = true; }
   
    
      if (Alerts_On && i == 1) {
       if (MathAbs(ExtForceBuffer[i]) < Alert_Trigger_Leve2) {
        if (EntryAllowed) {
         Alert("ForceIndex Possible SELL watch out !... (M",Period()," ",Symbol(),")"); 
      
         if (Alerts_On && i == 1) {
             else EntryAllowed = true; }
  
    if (MathAbs(ExtForceBuffer[i]) > Alert_Trigger_Leve3) {
     if (EntryAllowed) {
      Alert("ForceIndex GO BUY !!! (M",Period()," ",Symbol(),")"); // alert by omelette
      EntryAllowed = false; } }
            else EntryAllowed = true; }
   
    
      if (Alerts_On && i == 1) {
       if (MathAbs(ExtForceBuffer[i]) < Alert_Trigger_Leve4) {
        if (EntryAllowed) {
         Alert("ForceIndex GO SELL !!! (M",Period()," ",Symbol(),")"); 
            else EntryAllowed = true; }
        
         EntryAllowed = false; } }
     else EntryAllowed = true; }
   }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+